-module(test).

-export([test/0, test2/0,
  testn/1, testn_b/1]).


test() ->
  Timestamp_Now = erlang:system_time(second),
  L = lists:seq(1, 15),
  [myapp_events:add_task(integer_to_list(X), X, dynamic, X + 10) || X <- L, X rem 2 =:= 0],
  [myapp_events:add_task(integer_to_list(X), X, static, Timestamp_Now + X + 5) || X <- L, X rem 2 =:= 1],
  
  spawn(fun() ->
    timer:sleep(3000),
    
    myapp_events:add_task("12", 12, dynamic, 50),
    myapp_events:add_task("13", 13, static, Timestamp_Now + 80),
    
    myapp_events:delete_task("9", 9),
    myapp_events:delete_task("14", 14),
    
    ok
  end),
  
  ok.


test2() ->
  Timestamp_Now = erlang:system_time(second),
  L = lists:seq(1, 15),
  [myapp_events2:add_task(integer_to_list(X), X, dynamic, X + 10) || X <- L, X rem 2 =:= 0],
  [myapp_events2:add_task(integer_to_list(X), X, static, Timestamp_Now + X + 5) || X <- L, X rem 2 =:= 1],
  
  spawn(fun() ->
    timer:sleep(3000),
    
    myapp_events2:add_task("12", 12, dynamic, 50),
    myapp_events2:add_task("13", 13, static, Timestamp_Now + 80),
    
    myapp_events2:delete_task("9", 9),
    myapp_events2:delete_task("14", 14),
    
    ok
  end),
  
  ok.


testn(0) -> io:format("~p~n",["the end"]);
testn(T) -> % T -- умовно секунди - кількість циклів по 20_000 нових заявок та 20_000 видалень
  spawn(fun() ->
    timer:sleep(1000),
    testn(T - 1)
  end),
  
  spawn(fun() ->
    T1 = erlang:system_time(millisecond),
    testn_h(T rem 2 =:= 0),
    T2 = erlang:system_time(millisecond),
    io:format("~p~n",[T2 - T1]),
    ok
  end),
  ok.

testn_h(true) ->
  [myapp_events2:add_task(integer_to_list(X), X, dynamic, 5) || X <- lists:seq(1, 20_000)],
  [myapp_events2:delete_task(integer_to_list(X), X) || X <- lists:seq(10_001, 30_000)],
  ok;
testn_h(_) ->
  Timestamp_Now = erlang:system_time(second),
  [myapp_events2:add_task(integer_to_list(X) ++ ".", X, static, Timestamp_Now + 5) || X <- lists:seq(20_001, 40_000)],
  [myapp_events2:delete_task(integer_to_list(X) ++ ".", X) || X <- lists:seq(30_001, 50_000)],
  ok.


testn_b(0) -> io:format("~p~n",["the end"]);
testn_b(T) -> % T -- умовно секунди - кількість циклів по 20_000 нових заявок та 20_000 видалень
  spawn(fun() ->
    timer:sleep(1000),
    testn_b(T - 1)
  end),
  
  spawn(fun() ->
    T1 = erlang:system_time(millisecond),
    testn_h2(T rem 2 =:= 0),
    T2 = erlang:system_time(millisecond),
    io:format("~p~n",[T2 - T1]),
    ok
  end),
  ok.

testn_h2(true) ->
  [myapp_events2:add_task_b(integer_to_list(X), X, dynamic, 5) || X <- lists:seq(1, 20_000)],
  [myapp_events2:delete_task_b(integer_to_list(X), X) || X <- lists:seq(10_001, 30_000)],
  ok;
testn_h2(_) ->
  Timestamp_Now = erlang:system_time(second),
  [myapp_events2:add_task_b(integer_to_list(X) ++ ".", X, static, Timestamp_Now + 5) || X <- lists:seq(20_001, 40_000)],
  [myapp_events2:delete_task_b(integer_to_list(X) ++ ".", X) || X <- lists:seq(30_001, 50_000)],
  ok.



